# report.rb
# A collection of helper functions
# that make API calls and then return
# wanted information.

module NessusAPI
  module Helpers
    def self.getSeverity(uuid, session=Session.current)
      result = 0
      xml = session.get('report2/hosts', {'report' => uuid})
      xml.css('item').each do |i|
        level = i.css('severityLevel').text.to_i
        threat = i.css('count').text.to_i
        if level > result
          if threat > 0
            result = level
          end
        end
      end
      return result
    end

    def self.translateSeverity(n)
      if n < 0 or n > 4
        return 'Unknown'
      end

      return {0 => 'Minimal',
              1 => 'Low',
              2 => 'Medium',
              3 => 'High',
              4 => 'Critical'}[n]
    end
  end
end
