# template.rb
# Does API things with installation.

module NessusAPI
  class Template
    # The class that handles the specific
    # calls for templates.
    def initialize(template_name, policy_id, target,
                  startTime=nil, rRules=nil,
                  session=Session.current)
      @name = template_name
      @policy = policy_id
      @target = target
      @session = session
      @time = startTime
      @rules = rRules
      params = optional({'template_name' => @name, 'policy_id' => @policy,
                'target' => @target}, @time, @rules)
      @uuid = @session.get('scan/template/new', params).at_css("name").text
    end

    def edit(old_name, new_name, policy_id, target,
             startTime=nil, rRules=nil)
      params = optional({'template' => old_name, 'template_name' => new_name,
                'policy_id' => policy_id, 'target' => target})
      if @session.get('scan/template/edit', params).css('status').text == 'OK'
        return true
      else
        return false
      end
    end

    def launch(uuid=@uuid)
      # Returns the uuid of a template scan.
      return @session.get('scan/template/launch',
                     {'template' => uuid}).at_css('uuid').text
    end

    def delete(uuid=@uuid)
      if @session.get('scan/template/delete',
                     {'template' => uuid}).css('status').text == 'OK'
        return true
      else
        return false
      end
    end

    def optional(params, startTime, rRules)
      # Returns a hash given with a new hash
      # with the optional attributes added.
      if !startTime.nil?
        params['startTime'] = startTime
      end
      if !rRules.nil?
        params['rRules'] = rRules
      end
      return params
    end
  end
end
